<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

define('_JEXEC', 1);
define('JPATH_BASE', '../../../');
require_once JPATH_BASE . 'includes/defines.php';
require_once JPATH_BASE . 'includes/framework.php';

// Create the Application
$app = JFactory::getApplication('site');
$plugin = JPluginHelper::getPlugin('system', 'minimumorderpercategory4vm');
$params = new JRegistry($plugin->params);


function getProductMinOrder($productId){
	$db = JFactory::getDbo();

	// Create a new query object.
	$query = $db->getQuery(true);

	// Select all records from the user profile table where key begins with "custom.".
	// Order it by the ordering field.
	$query->select($db->quoteName(array('product_params')));
	$query->from($db->quoteName('#__virtuemart_products'));
	$query->where($db->quoteName('virtuemart_product_id') . ' = ' . $db->quote($productId));
	

	// Reset the query using our newly populated query object.
	$db->setQuery($query);

	// Load the results as a list of stdClass objects (see later for more options on retrieving data).
	return $db->loadResult();
}
function updateProductMinOrder($productId,$min){
	
	$status =  getProductMinOrder($productId);
	$statusParts = explode("|",$status);
	if(strpos($statusParts[0], "min_order_level") !== false){
		$statusParts[0]='min_order_level="'.$min.'"';
	}
	$newStatus = implode("|",$statusParts);
	echo '<br>product: '.$productId.' '.$status;
	echo '<br>product: '.$productId.' '.$newStatus;
	
	$db = JFactory::getDbo();

	$query = $db->getQuery(true);

	// Fields to update.
	$fields = array(
		$db->quoteName('product_params') . ' = ' . $db->quote($newStatus),		
	);

	// Conditions for which records should be updated.
	$conditions = array(		
		$db->quoteName('virtuemart_product_id') . ' = ' . $db->quote($productId)
	);

	$query->update($db->quoteName('#__virtuemart_products'))->set($fields)->where($conditions);

	$db->setQuery($query);

	$result = $db->execute();
//echo $query;exit;	
}


function getCategoryProducts($categoryId){
	$db = JFactory::getDbo();

	// Create a new query object.
	$query = $db->getQuery(true);

	// Select all records from the user profile table where key begins with "custom.".
	// Order it by the ordering field.
	$query->select($db->quoteName(array('virtuemart_product_id')));
	$query->from($db->quoteName('#__virtuemart_product_categories'));
	$query->where($db->quoteName('virtuemart_category_id') . ' = ' . $db->quote($categoryId));
	

	// Reset the query using our newly populated query object.
	$db->setQuery($query);

	// Load the results as a list of stdClass objects (see later for more options on retrieving data).
	return $db->loadObjectList();
}


function getSubCatsList($catId){
		$db = JFactory::getDbo();

		// Create a new query object.
		$query = $db->getQuery(true);

		// Select all records from the user profile table where key begins with "custom.".
		// Order it by the ordering field.
		$query->select($db->quoteName('category_child_id','virtuemart_category_id'));
		$query->from($db->quoteName('#__virtuemart_category_categories'));
		$query->where($db->quoteName('category_parent_id') . ' = ' . $db->quote($catId));
		

		// Reset the query using our newly populated query object.
		$db->setQuery($query);

		// Load the results as a list of stdClass objects (see later for more options on retrieving data).
		$subCats = $db->loadObjectList();
		$subCatsReturn = array();
		foreach($subCats as $subCat){
			
			$subCatsReturn = array_merge($subCats,getSubCatsList($subCat->virtuemart_category_id));
		}
		return $subCatsReturn;
	}

function setCategoryProductLimits($categoryId,$limit){
	echo 'getting category: '.$categoryId;
	$subCats = getSubCatsList($categoryId);
	echo '#######<br><br><br><br>';
	
	$categoryProducts = getCategoryProducts($categoryId);
	foreach($categoryProducts as $product){
		echo 'product: '.$product->virtuemart_product_id.': '.$limit.'<br>';
		updateProductMinOrder($product->virtuemart_product_id,$limit);
	}
	
	foreach($subCats as $subCat){
		
		setCategoryProductLimits($subCat->virtuemart_category_id,$limit);
	}
}

$limits = $params->get('storedata','');
$limitsA = explode("\n",$limits);

foreach($limitsA as $limit){
	echo $limit."<br>";
	$limitA = explode(":",$limit);
	
	$limitA[1] = trim($limitA[1]);
	setCategoryProductLimits($limitA[0],$limitA[1]);
	
	
}

