<?php
/**
 * @version    1
 * @package    plgSystemMinimumorderpercategory4vm
 * @author     pageup.gr https://pageup.gr
 * @copyright  Copyright (c) 2019 - 2020 pageup.gr. All rights reserved.
 * @license    GNU/GPL license: https://www.gnu.org/copyleft/gpl.html
 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
use Joomla\CMS\Factory;
class plgSystemMinimumorderpercategory4vm extends JPlugin
{
	public function onBeforeCompileHead()
	{
		//only going to run these in the backend for now
		$app = JFactory::getApplication();
		
		$input = Factory::getApplication()->input;
		$view = $input->get('view', '', 'string');
		$option = $input->get('option', '', 'string');
		$format = $input->get('format', '', 'string');
		$task = $input->get('task', '', 'string');
		$document = JFactory::getDocument();
		if (!$app->isSite()) {
			if($option='com_plugin' && $view=='plugin' && $this->_name=='minimumorderpercategory4vm'){								
				$document->addScript(JUri::root().'plugins/system/minimumorderpercategory4vm/assets/js/plugin.js' );
			}
		}else if (($app->isSite() && $option=="com_virtuemart" && $view="productdetails") && ($app->isSite() && $option=="com_virtuemart" && $view="cart") ) {
			$document->addScript(JUri::root().'plugins/system/minimumorderpercategory4vm/assets/js/pluginFe.js' );
			$document->addStylesheet(JUri::root().'plugins/system/minimumorderpercategory4vm/assets/css/pluginFe.css' );
		}else if ($app->isSite() && $option=="com_virtuemart" && $view=="cart" && $task=="viewJS" && $format=="json")  {			
			$document->addScript(JUri::root().'plugins/system/minimumorderpercategory4vm/assets/js/pluginCartFe.js' );
			
		}
	

		$document = JFactory::getDocument();
		$document->addScript(JUri::root().'plugins/system/minimumorderpercategory4vm/assets/js/pluginFe.js' );
	}

	function getProductCategories($productId){

		$db = JFactory::getDbo();

		// Create a new query object.
		$query = $db->getQuery(true);

		// Select all records from the user profile table where key begins with "custom.".
		// Order it by the ordering field.
		$query->select($db->quoteName(array('virtuemart_category_id')));
		$query->from($db->quoteName('#__virtuemart_product_categories'));
		$query->where($db->quoteName('virtuemart_product_id') . ' = ' . $db->quote($productId));
		

		// Reset the query using our newly populated query object.
		$db->setQuery($query);

		// Load the results as a list of stdClass objects (see later for more options on retrieving data).
		return $db->loadObjectList();
		
	}
	
	function getSubCatsList($catId){
		$db = JFactory::getDbo();

		// Create a new query object.
		$query = $db->getQuery(true);

		// Select all records from the user profile table where key begins with "custom.".
		// Order it by the ordering field.
		$query->select($db->quoteName('category_child_id','virtuemart_category_id'));
		$query->from($db->quoteName('#__virtuemart_category_categories'));
		$query->where($db->quoteName('category_parent_id') . ' = ' . $db->quote($catId));
		

		// Reset the query using our newly populated query object.
		$db->setQuery($query);

		// Load the results as a list of stdClass objects (see later for more options on retrieving data).
		$subCats = $db->loadObjectList();
		$subCatsReturn = array();
		foreach($subCats as $subCat){
			$subCatsReturn = array_merge($subCats,$this->getSubCatsList($subCat));
		}
		return $subCatsReturn;
	}

    function onBeforeRender() {
		$app = JFactory::getApplication();
		$input = Factory::getApplication()->input;
		$view = $input->get('view', '', 'string');
		
		$option = $input->get('option', '', 'string');
		
		//echo $option.' '.$view.' '. $task.' '.$format;
		//mail("info@pageup.gr",'Test',"test");
		if (JFactory::getDocument()->getType() != 'html') {
				return;
		}
		else if ($app->isSite() && $option=="com_virtuemart" && $view=="productdetails")  {
			
			$document=JFactory::getDocument();
			$minForCategory = 1;
			$body=JResponse::getBody();
			$configuration = $this->params->get('storedata', '');
			$confields = explode("\n",$configuration);
			$virtuemart_product_id = $input->get('virtuemart_product_id', '', 'string');
			$categories = $this->getProductCategories($virtuemart_product_id);
			//print_r($confields);return;
			//print_r($this);
			foreach($categories as $category){
				
				foreach($confields as $confField){
					$cFieldArr = explode(":",$confField);
					$cCat=@$cFieldArr[0];
					$cLimit=@$cFieldArr[1];
					
					if($cCat==$category->virtuemart_category_id && $cLimit){
						$minForCategory = $cLimit;
					}else{  //to do add subcategories automatically
						/*foreach($this->getSubCatsList($cCat) as $subCat){
							if($subCat->virtuemart_category_id == $category->virtuemart_category_id){
								$minForCategory = $cLimit;
							}
						}*/
						
					}
				}				
			}
			$html = '<script> 
				var minForCategory='.$minForCategory.';				
			 </script>';
			 
			 echo $html;
			 
			$body=str_replace('</body>',$html.'</body>',$body);
			JResponse::setBody($body);
			//return TRUE;
		}
	}
}
